#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

int main(int argc,char *argv[])
{
  int socked, i, addr_len, count;
  struct sockaddr_in sid_in,sid_out;
  struct hostent *host;
  char data_out[1024], data_in[1024];
  
  host= (struct hostent *) gethostbyname(argv[1]); 

  sid_in.sin_family = AF_INET; //network
  sid_in.sin_addr = *((struct in_addr *) host->h_addr); //network address
  bzero(&(sid_in.sin_zero),sizeof(sid_in.sin_zero));
  addr_len = sizeof(struct sockaddr);

  if ((socked = socket(AF_INET, SOCK_DGRAM, 0)) == -1) //anigma socket
    {
       perror("CLIENT: socket error");
       exit(1);
    }

  for(i=1; i<argc-2; i++) { //gia kathe port
   //dimourgia UDP socket
    socked = socket(AF_INET, SOCK_DGRAM, 0);
    sid_in.sin_port = htons(atoi(argv[i+1]));
    //apostoli ping ston server
    strcpy(data_out, "ping"); 
    sendto(socked, data_out, strlen(data_out), 0, (struct sockaddr *) &sid_in, sizeof(sid_in));
    //apantisi apo ton server
    bzero(&(data_in), sizeof(data_in)); //katharismos buffer
    count = recvfrom(socked, data_in, sizeof(data_in), 0, (struct sockaddr *) &sid_in, &addr_len);
    printf("[%s:%d] %s [%d]\n", inet_ntoa(sid_out.sin_addr), ntohs(sid_in.sin_port), data_in, count);
    close(socked); 
  }

  //dimourgia TCP socket
  if ((socked = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("SERVER: Socket error\n");
    exit(1);
  }
  sid_in.sin_port = htons(atoi(argv[argc-1]));
  connect(socked, (struct sockaddr *) &sid_in, addr_len);
  strcpy(data_out, "ping"); 
  write(socked, data_out, strlen(data_out));
  bzero(&(data_in), sizeof(data_in));
  count=read(socked, data_in, sizeof(data_in));
  printf("[%s:%d] %s [%d]\n", inet_ntoa(sid_out.sin_addr), ntohs(sid_in.sin_port), data_in, count);
  
  close(socked);
}


